#ifndef _BASEAPPLICATION_H_
#define _BASEAPPLICATION_H_

#include <fstream>
#include <stdlib.h>

#include "Input.h"
#include "D3D.h"
#include "Camera.h"
#include "Timer.h"
#include "INIReader.h"
#include "BaseScene.h"
#include "TestScene.h"


class BaseApplication
{
public:
	BaseApplication();
	~BaseApplication();
	virtual void init(HINSTANCE hinstance, HWND hwnd, int screenWidth, int screenHeight, Input *input, INIReader* iniReader);

	virtual bool Frame();

protected:
	virtual void HandleInput(float);
	AntiAliasingSetting ReadAASetting(std::string stringSetting);
	void EditShaderSettingsFile(int sampleCount);
protected:
	HWND m_hwnd;
	int m_screenWidth, m_screenHeight, m_resolutionWidth, m_resolutionHeight;
	POINT cursor;
	Input* m_Input;
	D3D* m_Direct3D;
	Timer* m_Timer;
	BaseScene* m_Scene;
};
#endif