#ifndef _BUFFERSCALINGSHADER_H_
#define _BUFFERSCALINGSHADER_H_

#include "BaseShader.h"
#include "QuadMesh.h"

class BufferScalingShader : public BaseShader
{
	struct ResolutionDataBuffer
	{
		float resolutionWidth;
		float resolutionHeight;
		float windowWidth;
		float windowHeight;
	};

public:
	BufferScalingShader(ID3D11Device* device, HWND hwnd);
	~BufferScalingShader();

	void SetBuffers(ID3D11ShaderResourceView* src, ID3D11RenderTargetView* dest);

	void Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer);

protected:
	void InitShader(WCHAR* vsFilename, WCHAR* psFilename);

protected:
	ID3D11ShaderResourceView* m_src;
	ID3D11RenderTargetView* m_dest;
	BaseMesh *m_renderWindow;
	ID3D11Buffer* m_resolutionBuffer;
};

#endif