#ifndef _DOFDISKSHADER_H_
#define _DOFDISKSHADER_H_

#include "BaseShader.h"
#include "QuadMesh.h"

static const int NUM_DOF_TAPS = 12;

class DoFDiskShader : public BaseShader
{
	struct PSBlurFactorsBuffer
	{
		float focalWidth;
		float focalDistance;
		float farClip;
		float maxCoC;
		//XMFLOAT2 filterTaps[NUM_DOF_TAPS];
	};

public:
	DoFDiskShader(ID3D11Device* device, HWND hwnd);
	~DoFDiskShader();

	void Render(ID3D11DeviceContext* deviceContext, D3D* direct3d, void* resourceContainer);

protected:
	void InitShader(WCHAR*, WCHAR*);

protected:
	ID3D11Buffer* m_blurFactorsBuffer;
	BaseMesh* m_renderWindow;
};

#endif