#include "DoFGaussianShader.h"
#include "ResourceContainer.h"

DoFGaussianShader::DoFGaussianShader(ID3D11Device* device, HWND hwnd, bool depthEnabled) : BaseShader(device, hwnd)
{
	m_depthEnabled = depthEnabled;
	m_postProcessShader = true;
	InitShader(L"../res/shaders/post_process_vs.hlsl", L"../res/shaders/dof_buffer_blur_ps.hlsl");
}

DoFGaussianShader::~DoFGaussianShader()
{
	if (m_blurFactorsBuffer)
	{
		m_blurFactorsBuffer->Release();
		m_blurFactorsBuffer = 0;
	}

	BaseShader::~BaseShader();
}

void DoFGaussianShader::InitShader(WCHAR* vsFilename, WCHAR* psFilename)
{
	loadVertexShader(vsFilename);
	loadPixelShader(psFilename);

	m_blurFactorsBuffer = D3D::instance()->CreateConstantBuffer(sizeof(PSBlurFactorsBuffer), true, true, NULL);
}

void DoFGaussianShader::Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer)
{

}