#ifndef _DOFGAUSSIANSHADER_H_
#define _DOFGAUSSIANSHADER_H_

#include "BaseShader.h"
#include "GaussianBlurShader.h"

class DoFGaussianShader : public BaseShader
{
	struct PSBlurFactorsBuffer
	{
		float attenuation;
		float focalWidth;
		float focalDistance;
		float farClip;
	};

public:
	DoFGaussianShader(ID3D11Device* device, HWND hwnd, bool depthEnabled);
	~DoFGaussianShader();

	void Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer);

protected:
	void InitShader(WCHAR*, WCHAR*);

protected:
	bool m_depthEnabled;
	
	ID3D11Buffer* m_blurFactorsBuffer;

};

#endif