#include "FloatParameter.h"

FloatParameter::FloatParameter(int count, float* initialData)
{
	if (count > 0)
	{
		m_count = count;
		m_floats = new float[count];

		if (initialData)
		{
			std::memcpy(m_floats, initialData, count * sizeof(float));
		}
	}
}

FloatParameter::FloatParameter(FloatParameter& copy)
{
	delete[] m_floats;
	m_floats = 0;

	m_count = copy.m_count;
	m_floats = new float[m_count];

	std::memcpy(m_floats, copy.m_floats, m_count * sizeof(float));
}

FloatParameter::~FloatParameter()
{
	delete[] m_floats;
	m_floats = 0;
}

void FloatParameter::UpdateParameter(int index, float data)
{
	if (index < m_count)
	{
		m_floats[index] = data;
	}
}

void FloatParameter::UpdateAllData(float* data)
{
	std::memcpy(m_floats, data, m_count * sizeof(float));
}

float FloatParameter::GetParameter(int index)
{
	if (index < 0)
		index = 0;
	else if (index >= m_count)
		index = m_count - 1;

	return m_floats[index];
}

void FloatParameter::GetAllData(float* dest)
{
	std::memcpy(dest, m_floats, m_count * sizeof(float));
}

int FloatParameter::GetCount()
{
	return m_count;
}