#include "GaussianBlurShader.h"
#include "ResourceContainer.h"

GaussianBlurShader::GaussianBlurShader(ID3D11Device* device, HWND hwnd, bool depthEnabled) : BaseShader(device, hwnd)
{
	m_depthEnabled = depthEnabled;
	m_postProcessShader = true;

	if (depthEnabled)
		InitShader(L"../res/shaders/post_process_vs.hlsl", L"../res/shaders/gaussian_depth_blur_ps.hlsl");
	else
		InitShader(L"../res/shaders/post_process_vs.hlsl", L"../res/shaders/gaussian_blur_ps.hlsl");

}

GaussianBlurShader::~GaussianBlurShader()
{
	if (m_blurFactorsBuffer)
	{
		m_blurFactorsBuffer->Release();
		m_blurFactorsBuffer = 0;
	}

	BaseShader::~BaseShader();
}

void GaussianBlurShader::InitShader(WCHAR* vsFilename, WCHAR* psFilename)
{
	loadVertexShader(vsFilename);
	loadVertexShader(psFilename);

	m_blurFactorsBuffer = D3D::instance()->CreateConstantBuffer(sizeof(PSBlurFactorsBuffer), true, true, NULL);
}

void GaussianBlurShader::Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer)
{

}