#ifndef _GAUSSIANBLURSHADER_H_
#define _GAUSSIANBLURSHADER_H_

#include "BaseShader.h"

class GaussianBlurShader : public BaseShader
{
	struct PSBlurFactorsBuffer
	{
		float blurRadius;
		float blurDirection;
		XMFLOAT2 sourceDimensions;
	};

public:
	GaussianBlurShader(ID3D11Device* device, HWND hwnd, bool depthEnabled);
	~GaussianBlurShader();

	void Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer);

protected:
	void InitShader(WCHAR*, WCHAR*);

protected:
	ID3D11Buffer* m_blurFactorsBuffer;

	bool m_depthEnabled;

};

#endif