#include "INIReader.h"

INIReader::INIReader(char* filename)
{
	if (filename != NULL)
	{
		m_filename = filename;
	}

	m_sectionList.clear();
	m_sectionDataList.clear();
}

INIReader::INIReader()
{
	m_sectionList.clear();
	m_sectionDataList.clear();
}

INIReader::~INIReader()
{
	m_sectionList.clear();
	m_sectionDataList.clear();
	m_filename = NULL;
}

string INIReader::getValue(string key, string section)
{	char result[255];

	m_returnValue = GetPrivateProfileString((LPCSTR)section.c_str(), (LPCSTR)key.c_str(), "", result, 255, (LPCSTR)m_filename);

	return result;
}

long INIReader::setValue(string value, string key, string section)
{
	m_returnValue = WritePrivateProfileString(section.c_str(), key.c_str(), value.c_str(), m_filename);

	return m_returnValue;
}

bool INIReader::sectionExists(string section)
{
	char result[100];
	char* aux;

	m_returnValue = GetPrivateProfileString((LPCSTR)section.c_str(), NULL, "", result, 90, (LPCSTR)m_filename);

	return (m_returnValue > 0);
}

list<string> INIReader::getSectionNames()
{
	char result[2000];

	m_sectionList.clear();

	m_returnValue = GetPrivateProfileSectionNames(result, 2000, (LPCSTR)m_filename);

	string sectionName;
	for (int i = 0; i < m_returnValue; ++i)
	{
		if (result[i] != '\0')
		{
			sectionName = sectionName + result[i];
		}
		else
		{
			if (sectionName != "")
			{
				m_sectionList.push_back(sectionName);
			}
			sectionName.clear();
		}
	}

	return m_sectionList;
}

list<string> INIReader::getSectionData(string section)
{
	char result[2000];

	m_sectionDataList.clear();
	m_returnValue = GetPrivateProfileSection((LPCSTR)section.c_str(), result, 2000, (LPCSTR)m_filename);

	string sectionData;
	for (int i = 0; i < m_returnValue; ++i)
	{
		if (result[i] != '\0')
		{
			sectionData = sectionData + result[i];
		}
		else
		{
			if (sectionData != "")
			{
				m_sectionDataList.push_back(sectionData);
			}
			sectionData.clear();
		}
	}

	return m_sectionDataList;
}

void INIReader::setFilename(char* filename)
{
	m_filename = filename;
}