#ifndef _INIREADER_H_
#define _INIREADER_H_

#include <Windows.h>
#include <list>
#include <string>

using std::list;
using std::string;

class INIReader
{
public:
	INIReader();
	INIReader(char* filename);
	~INIReader();

	void setFilename(char* filename);

	list<string> getSectionNames();
	list<string> getSectionData(string section);

	bool sectionExists(string section);

	long setValue(string value, string key, string section);
	string getValue(string key, string section);

protected:
	list<string> m_sectionList;
	list<string> m_sectionDataList;

	string m_section;
	long m_returnValue;

	char* m_filename;
};
#endif