#ifndef _SHADOWMAPSHADER_H_
#define _SHADOWMAPSHADER_H_

#include "../DXFramework/BaseShader.h"

class ShadowMapShader : public BaseShader
{
protected:
	struct LightDataBuffer
	{
		XMFLOAT3 lightPos;
		float padding;
	};

	struct LightMatrixBuffer
	{
		XMMATRIX world;
		XMMATRIX lightView;
		XMMATRIX lightProj;
	};

public:
	ShadowMapShader(ID3D11Device* device, HWND hwnd);
	~ShadowMapShader();

	void Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer);

protected:
	void InitShader(WCHAR* vsFilename, WCHAR* psFilename);

protected:
	ID3D11Buffer* m_lightDataBuffer;
};

#endif