#ifndef _SYSTEM_H_
#define _SYSTEM_H_

#include <windows.h>
#include "Input.h"
#include "INIReader.h"
#include "BaseApplication.h"

class System
{
public:
	System(BaseApplication* application);
	~System();

	void Run();

	LRESULT CALLBACK MessageHandler(HWND, UINT, WPARAM, LPARAM);

protected:
	virtual bool Frame();
	virtual bool InitializeWindows(int&, int&);
	virtual void ShutdownWindows();

protected:
	LPCSTR m_appName;
	HINSTANCE m_hinstance;
	HWND m_hwnd;
	Input m_Input;
	INIReader m_INIReader;
	BaseApplication* m_Application;

	bool m_fullscreen;
	bool m_vsync;

	static LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
};

static System* ApplicationHandle = 0;


#endif