#ifndef _UNORDEREDACCESSVIEW_H_
#define _UNORDEREDACCESSVIEW_H_

#include <d3d11.h>

class UnorderedAccessView
{
public:
	UnorderedAccessView();
	~UnorderedAccessView();

	void InitRWTexture(ID3D11Device* device, ID3D11DeviceContext* deviceContext, int width, int height, D3D11_SUBRESOURCE_DATA* initialData);
	void InitStructuredBuffer(ID3D11Device* device, ID3D11DeviceContext* deviceContext, int elementSize, int numElements, D3D11_SUBRESOURCE_DATA* initialData);

	ID3D11UnorderedAccessView* GetUAV();
	ID3D11ShaderResourceView* GetSRV();

protected:
	ID3D11UnorderedAccessView* m_UAV;
	ID3D11ShaderResourceView* m_SRV;
	ID3D11Buffer* m_structuredBuffer;
};
#endif