#define FXAA_PC 1
#define FXAA_HLSL_5 1
#define FXAA_QUALITY__PRESET 15

#include "FXAA3_11.h"

// Source textures
Texture2D sourceTexture : register(t0);

// Samplers
SamplerState sourceSampler : register(s0);

// I/O Structs
struct VertexOutput
{
	float4 pos : SV_POSITION;
	float2 tex : TEXCOORD0;
};

// Constant
cbuffer FxaaFactors : register(b0)
{
	float fxaaSubpixelAliasingRemoval;
	float fxaaEdgeThreshold;
	float fxaaEdgeThresholdMin;
	float fxaaGather4Alpha;
	float fxaaDiscard;
	float fxaaGreenAsLuma;
	float2 fxaaQualityRcpFrame;
	float fxaaQualityPreset;
	float3 padding;
}

float4 main(VertexOutput input) : SV_TARGET
{
	FxaaTex tex;
	tex.smpl = sourceSampler;
	tex.tex = sourceTexture;

	return FxaaPixelShader(input.tex, float4(0,0,0,0), tex, tex, tex, fxaaQualityRcpFrame,
							float4(0,0,0,0), float4(0,0,0,0), float4(0,0,0,0), fxaaSubpixelAliasingRemoval, fxaaEdgeThreshold,
							fxaaEdgeThresholdMin, 0, 0, 0, float4(0,0,0,0));
}