//Constants
cbuffer Transforms
{
	matrix worldMatrix;
	matrix viewMatrix;
	matrix projectionMatrix;
};

//Input/Output structures (lazy implementation)
struct VSInput
{
	float4 position : POSITION;
	float2 texCoord : TEXCOORD0;
	float3 normal : NORMAL;
	float4 tangent : TANGENT;
};

struct VSOutput
{
	float4 clipPosition : SV_Position;
	float2 texCoord : TEXCOORD0;
};

//final pass vertex shader
VSOutput main(in VSInput input)
{
	VSOutput output;

	input.position.w = 1.0f;

	//calculate the clip-space position
	output.clipPosition = mul(input.position, worldMatrix);
	output.clipPosition = mul(output.clipPosition, viewMatrix);
	output.clipPosition = mul(output.clipPosition, projectionMatrix);

	//pass along the texture coordinates
	output.texCoord = input.texCoord;

	return output;
}