#include "../res/shaders/shader_settings.hlsli"
//Textures
#if SAMPLE_COUNT > 1
	Texture2DMS<float4, SAMPLE_COUNT> gBufferTexture : register(t0);
#else
	Texture2D gBufferTexture : register(t0);
#endif

float4 main(in float4 screenPos : SV_Position) : SV_Target0
{
	//sample the mask from the g-buffer
	int2 sampleIndices = int2(screenPos.xy);
	float mask = 0.0f;

#if SAMPLE_COUNT > 1 
	for (uint i = 0; i < SAMPLE_COUNT; ++i)
		mask += gBufferTexture.Load(sampleIndices, i).z;
#else
	//mask += gBufferTexture.Load(int3(sampleIndices.xy, 0)).z;
#endif
	if (mask == 0.0f)
		clip(-1.0f);

	return 0.0f;
}